Index: admin/preferences.php
===================================================================
--- admin/preferences.php	(revision 907)
+++ admin/preferences.php	(revision 745)
@@ -42,5 +42,4 @@
 }
 $user_ui_iconset = @$core->auth->user_prefs->interface->iconset;
-$user_ui_nofavmenu = $core->auth->user_prefs->interface->nofavmenu;
 
 $default_tab = !empty($_GET['tab']) ? html::escapeHTML($_GET['tab']) : 'user-profile';
@@ -162,6 +161,6 @@
 		$cur->user_options = new ArrayObject($user_options);
 		
-		# --BEHAVIOR-- adminBeforeUserOptionsUpdate
-		$core->callBehavior('adminBeforeUserOptionsUpdate',$cur,$core->auth->userID());
+		# --BEHAVIOR-- adminBeforeUserUpdate
+		$core->callBehavior('adminBeforeUserUpdate',$cur,$core->auth->userID());
 		
 		# Update user prefs
@@ -176,11 +175,10 @@
 		}
 		$core->auth->user_prefs->interface->put('iconset',(!empty($_POST['user_ui_iconset']) ? $_POST['user_ui_iconset'] : ''));
-		$core->auth->user_prefs->interface->put('nofavmenu',!empty($_POST['user_ui_nofavmenu']),'boolean');
 		
 		# Udate user
 		$core->updUser($core->auth->userID(),$cur);
 		
-		# --BEHAVIOR-- adminAfterUserOptionsUpdate
-		$core->callBehavior('adminAfterUserOptionsUpdate',$cur,$core->auth->userID());
+		# --BEHAVIOR-- adminAfterUserUpdate
+		$core->callBehavior('adminAfterUserUpdate',$cur,$core->auth->userID());
 		
 		http::redirect('preferences.php?updated=1');
@@ -343,5 +341,5 @@
 	dcPage::jsLoad('js/_preferences.js').
 	($user_acc_nodragdrop ? '' : dcPage::jsLoad('js/_preferences-dragdrop.js')).
-	dcPage::jsLoad('js/jquery/jquery-ui.custom.js').
+	dcPage::jsLoad('js/jquery/jquery-ui-1.8.12.custom.min.js').
 	dcPage::jsPageTabs($default_tab).
 	dcPage::jsConfirmClose('user-form').
@@ -352,20 +350,20 @@
 
 if (!empty($_GET['upd'])) {
-	dcPage::message(__('Personal information has been successfully updated.'));
+		echo '<p class="message">'.__('Personal information has been successfully updated.').'</p>';
 }
 if (!empty($_GET['updated'])) {
-	dcPage::message(__('Personal options has been successfully updated.'));
+		echo '<p class="message">'.__('Personal options has been successfully updated.').'</p>';
 }
 if (!empty($_GET['append'])) {
-	dcPage::message(__('Favorites have been successfully added.'));
+		echo '<p class="message">'.__('Favorites have been successfully added.').'</p>';
 }
 if (!empty($_GET['neworder'])) {
-	dcPage::message(__('Favorites have been successfully updated.'));
+	echo '<p class="message">'.__('Favorites have been successfully updated.').'</p>';
 }
 if (!empty($_GET['removed'])) {
-	dcPage::message(__('Favorites have been successfully removed.'));
+		echo '<p class="message">'.__('Favorites have been successfully removed.').'</p>';
 }
 if (!empty($_GET['replaced'])) {
-	dcPage::message(__('Default favorites have been successfully updated.'));
+		echo '<p class="message">'.__('Default favorites have been successfully updated.').'</p>';
 }
 
@@ -458,9 +456,5 @@
 '<p><label for="user_ui_enhanceduploader" class="classic">'.
 form::checkbox('user_ui_enhanceduploader',1,$user_ui_enhanceduploader).' '.
-__('Activate enhanced uploader in media manager').'</label></p>'.
-
-'<p><label for="user_ui_nofavmenu" class="classic">'.
-form::checkbox('user_ui_nofavmenu',1,$user_ui_nofavmenu).' '.
-__('Hide My favorites menu').'</label></p>';
+__('Activate enhanced uploader in media manager').'</label></p>';
 
 if (count($iconsets_combo) > 1) {
Index: admin/services.php
===================================================================
--- admin/services.php	(revision 323)
+++ admin/services.php	(revision 782)
@@ -25,4 +25,5 @@
 $core->rest->addFunction('delMeta',array('dcRestMethods','delMeta'));
 $core->rest->addFunction('setPostMeta',array('dcRestMethods','setPostMeta'));
+$core->rest->addFunction('searchCommentAuthor',array('dcRestMethods','searchCommentAuthor'));
 $core->rest->addFunction('searchMeta',array('dcRestMethods','searchMeta'));
 
@@ -392,4 +393,29 @@
 		return $rsp;
 	}
+
+	public static function searchCommentAuthor($core,$get)
+	{
+		$q = !empty($get['q']) ? strtoupper($get['q']) : null;
+		
+		$strReq = 'SELECT DISTINCT C.comment_author '.
+			'FROM '.$core->prefix.'comment C '.
+			'INNER JOIN '.$core->prefix.'post P on C.post_id = P.post_id '.
+			'WHERE P.blog_id = \''.$core->blog->id.'\' '.
+			'AND UPPER(comment_author) like \'%'.$core->con->escape($q).'%\''
+			;
+		//echo $strReq;
+		$rs = $core->con->select($strReq);
+		$rsp = new xmlTag();
+		
+		while ($rs->fetch())
+		{
+			$author = new xmlTag('author');
+			$author->name=$rs->comment_author;
+			$rsp->insertNode($author);
+		}
+		
+		return $rsp;
+	}
+
 }
 ?>
Index: admin/trackbacks.php
===================================================================
--- admin/trackbacks.php	(revision 907)
+++ admin/trackbacks.php	(revision 510)
@@ -92,5 +92,5 @@
 
 if (!empty($_GET['sent'])) {
-	dcPage::message(__('All pings sent.'));
+		echo '<p class="message">'.__('All pings sent.').'</p>';
 }
 
Index: admin/update.php
===================================================================
--- admin/update.php	(revision 941)
+++ admin/update.php	(revision 769)
@@ -42,9 +42,4 @@
 $step = in_array($step,array('check','download','backup','unzip')) ? $step : '';
 
-$default_tab = !empty($_GET['tab']) ? html::escapeHTML($_GET['tab']) : 'update';
-if (!empty($_POST['backup_file'])) {
-	$default_tab = 'files';
-}
-
 $archives = array();
 foreach (files::scanDir(DC_BACKUP_PATH) as $v) {
@@ -53,9 +48,4 @@
 	}
 }
-if (!empty($archives)) {
-	$archives = array_reverse($archives);
-} else {
-	$default_tab = 'update';
-}
 
 # Revert or delete backup file
@@ -71,5 +61,5 @@
 				throw new Exception(sprintf(__('Unable to delete file %s'),html::escapeHTML($b_file)));
 			}
-			http::redirect($p_url.'?tab=files');
+			http::redirect($p_url);
 		}
 		
@@ -79,5 +69,5 @@
 			$zip->unzipAll(DC_BACKUP_PATH.'/');
 			@unlink(DC_BACKUP_PATH.'/'.$b_file);
-			http::redirect($p_url.'?tab=files');
+			http::redirect($p_url);
 		}
 	}
@@ -167,7 +157,5 @@
 /* DISPLAY Main page
 -------------------------------------------------------- */
-dcPage::open(__('Dotclear update'),
-	(!$step ? dcPage::jsPageTabs($default_tab) : '')
-);
+dcPage::open(__('Dotclear update'));
 
 if (!$core->error->flag()) {
@@ -177,5 +165,4 @@
 if (!$step)
 {
-	echo '<div class="multi-part" id="update" title="'.__('Dotclear update').'">';
 	if (empty($new_v))
 	{
@@ -196,10 +183,7 @@
 		'</form>';
 	}
-	echo '</div>';
 	
 	if (!empty($archives))
 	{
-		echo '<div class="multi-part" id="files" title="'.__('Manage backup files').'">';
-
 		echo
 		'<h3>'.__('Update backup files').'</h3>'.
@@ -224,6 +208,4 @@
 		$core->formNonce().'</p>'.
 		'</form>';
-
-		echo '</div>';
 	}
 }
Index: admin/user.php
===================================================================
--- admin/user.php	(revision 907)
+++ admin/user.php	(revision 557)
@@ -178,9 +178,9 @@
 
 if (!empty($_GET['upd'])) {
-	dcPage::message(__('User has been successfully updated.'));
+		echo '<p class="message">'.__('User has been successfully updated.').'</p>';
 }
 
 if (!empty($_GET['add'])) {
-	dcPage::message(__('User has been successfully created.'));
+		echo '<p class="message">'.__('User has been successfully created.').'</p>';
 }
 
@@ -290,13 +290,5 @@
 if ($user_id)
 {
-	echo '<div class="clear fieldset"><h3>'.__('Permissions').'</h3>'.
-	'<form action="users_actions.php" method="post">'.
-	'<p><input type="submit" value="'.__('Add new permissions').'" />'.
-	form::hidden(array('redir'),'user.php?id='.$user_id).
-	form::hidden(array('action'),'blogs').
-	form::hidden(array('users[]'),$user_id).
-	$core->formNonce().
-	'</p>'.
-	'</form>';
+	echo '<div class="clear fieldset"><h3>'.__('Permissions').'</h3>';
 	
 	$permissions = $core->getUserPermissions($user_id);
@@ -313,8 +305,8 @@
 			if (count($v['p']) > 0)
 			{
-				echo 
-				'<form action="users_actions.php" method="post">'.
-				'<h4><a href="blog.php?id='.html::escapeHTML($k).'">'.
-				html::escapeHTML($v['name']).'</a> ('.html::escapeHTML($k).')</h4>';
+				echo '<h4><a href="blog.php?id='.html::escapeHTML($k).'">'.
+				html::escapeHTML($v['name']).'</a> ('.html::escapeHTML($k).') - '.
+				'<a href="permissions.php?blog_id[]='.$k.'&amp;user_id[]='.$user_id.'">'
+				.__('Change permissions').'</a></h4>';
 				
 				echo '<ul>';
@@ -324,18 +316,13 @@
 					}
 				}
-				echo '</ul>'.
-				'<p><input type="submit" value="'.__('Change permissions').'" />'.
-				form::hidden(array('redir'),'user.php?id='.$user_id).
-				form::hidden(array('action'),'perms').
-				form::hidden(array('users[]'),$user_id).
-				form::hidden(array('blogs[]'),$k).
-				$core->formNonce().
-				'</p>'.
-				'</form>';
+				echo '</ul>';
 			}
 		}
 	}
 	
-	echo '</div>';
+	echo
+	'<p><a href="permissions_blog.php?user_id[]='.$user_id.'">'.
+	__('Add new permissions').'</a></p>'.
+	'</div>';
 }
 
Index: admin/users.php
===================================================================
--- admin/users.php	(revision 907)
+++ admin/users.php	(revision 782)
@@ -15,7 +15,31 @@
 dcPage::checkSuper();
 
+# Delete users
+if (!empty($delete_users))
+{
+	foreach ($delete_users as $u)
+	{
+		try
+		{
+			# --BEHAVIOR-- adminBeforeUserDelete
+			$core->callBehavior('adminBeforeUserDelete',$u);
+			if ($u != $core->auth->userID()) {
+				$core->delUser($u);
+			}
+		}
+		catch (Exception $e)
+		{
+			$core->error->add($e->getMessage());
+		}
+	}
+	if (!$core->error->flag()) {
+		http::redirect('users.php?del=1');
+	}
+}
+
+
 # Creating filter combo boxes
 $sortby_combo = array(
-__('Username') => 'user_id',
+__('Username') => 'U.user_id',
 __('Last Name') => 'user_name',
 __('First Name') => 'user_firstname',
@@ -31,5 +55,5 @@
 # Actions combo box
 $combo_action = array(
-	__('Set permissions') => 'blogs',
+	__('Set permissions') => 'setpermissions',
 	__('Delete') => 'deleteuser'
 );
@@ -40,18 +64,14 @@
 
 # Get users
-$page = !empty($_GET['page']) ? $_GET['page'] : 1;
-$nb_per_page =  30;
-
-if (!empty($_GET['nb']) && (integer) $_GET['nb'] > 0) {
-	$nb_per_page = $_GET['nb'];
-}
+$user_list = new adminUserList($core);
 
 $q = !empty($_GET['q']) ? $_GET['q'] : '';
-$sortby = !empty($_GET['sortby']) ?	$_GET['sortby'] : 'user_id';
-$order = !empty($_GET['order']) ?		$_GET['order'] : 'asc';
-
-$params['limit'] = array((($page-1)*$nb_per_page),$nb_per_page);
 
 $show_filters = false;
+
+$params = new ArrayObject();
+
+# - Limit, sortby and order filter
+$params = $user_list->applyFilters($params);
 
 # - Search filter
@@ -61,29 +81,11 @@
 }
 
-# - Sortby and order filter
-if ($sortby !== '' && in_array($sortby,$sortby_combo)) {
-	if ($order !== '' && in_array($order,$order_combo)) {
-		$params['order'] = $sortby.' '.$order;
-	} else {
-		$order='asc';
-	}
-	
-	if ($sortby != 'user_id' || $order != 'asc') {
-		$show_filters = true;
-	}
-} else {
-	$sortby = 'user_id';
-	$order = 'asc';
-}
-
-# Get users
 try {
 	$rs = $core->getUsers($params);
 	$counter = $core->getUsers($params,1);
-	$user_list = new adminUserList($core,$rs,$counter->f(0));
+	$user_list->setItems($rs,$counter->f(0));
 } catch (Exception $e) {
 	$core->error->add($e->getMessage());
 }
-
 
 /* DISPLAY
@@ -94,13 +96,10 @@
 }
 
-dcPage::open(__('Users'),$starting_script);
+dcPage::open(__('users'),$starting_script);
 
 if (!$core->error->flag())
 {
 	if (!empty($_GET['del'])) {
-		dcPage::message(__('User has been successfully removed.'));
-	}
-	if (!empty($_GET['upd'])) {
-		dcPage::message(__('The permissions have been successfully updated.'));
+		echo '<p class="message">'.__('User has been successfully removed.').'</p>';
 	}
 	
@@ -115,23 +114,10 @@
 	echo
 	'<form action="users.php" method="get" id="filters-form">'.
-	'<fieldset class="two-cols"><legend>'.__('Filters').'</legend>'.
+	'<fieldset><legend>'.__('Filters').'</legend>'.
 	
-	'<div class="col">'.
-	'<p><label for="sortby">'.__('Order by:').' '.
-	form::combo('sortby',$sortby_combo,$sortby).
-	'</label> '.
-	'<label for="order">'.__('Sort:').' '.
-	form::combo('order',$order_combo,$order).
-	'</label></p>'.
-	'</div>'.
-	
-	'<div class="col">'.
 	'<p><label for="q">'.__('Search:').' '.
 	form::field('q',20,255,html::escapeHTML($q)).
 	'</label></p>'.
-	'<p><label for="nb" class="classic">'.	form::field('nb',3,3,$nb_per_page).' '.
-	__('Users per page').'</label> '.
-	'<input type="submit" value="'.__('Apply filters').'" /></p>'.
-	'</div>'.
+	'<p><input type="submit" value="'.__('Apply filters').'" /></p>'.
 	
 	'<br class="clear" />'. //Opera sucks
@@ -140,6 +126,5 @@
 	
 	# Show users
-	$user_list->display($page,$nb_per_page,
-	'<form action="users_actions.php" method="post" id="form-users">'.
+	$user_list->display('<form action="dispatcher.php" method="get" id="form-users">'.
 	
 	'%s'.
@@ -148,16 +133,11 @@
 	'<p class="col checkboxes-helpers"></p>'.
 	
-	'<p class="col right"><label for="action" class="classic">'.
+	'<p class="col right"><label for="dispatch_action" class="classic">'.
 	__('Selected users action:').' '.
-	form::combo('action',$combo_action).
+	form::combo('dispatch_action',$combo_action).
 	'</label> '.
 	'<input type="submit" value="'.__('ok').'" />'.
-	form::hidden(array('q'),html::escapeHTML($q)).
-	form::hidden(array('sortby'),$sortby).
-	form::hidden(array('order'),$order).
-	form::hidden(array('page'),$page).
-	form::hidden(array('nb'),$nb_per_page).
-	$core->formNonce().
 	'</p>'.
+	$user_list->getFormFieldsAsHidden().
 	'</div>'.
 	'</form>'
